﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;

/// <summary>
/// Summary description for MyTemplateColumn
/// </summary>
/// 
namespace MyColumn
{
    public class MyTemplateColumn : GridTemplateColumn
    {
        
        public MyTemplateColumn()
        {

        }
        protected override void SetCurrentFilterValueToControl(TableCell cell)
        {
            if (this.CurrentFilterValue != "")
            {
                (cell.FindControl("Hidden" + this.UniqueName) as HiddenField).Value = this.CurrentFilterValue;
            }
        }
        protected override string GetCurrentFilterValueFromControl(TableCell cell)
        {
            return (cell.FindControl("Hidden" + this.UniqueName) as HiddenField).Value;
        }

        protected override void SetupFilterControls(TableCell cell)
        {
            ImageButton but = new ImageButton();
            but.ID = "TrueButton" + this.UniqueName;
            but.ImageUrl = "~/true.gif";
            but.Click += new ImageClickEventHandler(butTrue_Click);
            but.ToolTip = "True";
            cell.Controls.Add(but);

            but = new ImageButton();
            but.ID = "FalseButton" + this.UniqueName;
            but.ImageUrl = "~/false.gif";
            but.Click += new ImageClickEventHandler(butFalse_Click);
            but.ToolTip = "False"; 
            cell.Controls.Add(but);

            but = new ImageButton();
            but.ID = "ClearButton" + this.UniqueName;
            but.ImageUrl = "~/clear.gif";
            but.Click +=new ImageClickEventHandler(butClear_Click);
            but.ToolTip = "Clear Filter";
            cell.Controls.Add(but);

            HiddenField hidden = new HiddenField();
            hidden.ID = "Hidden" + this.UniqueName;
            cell.Controls.Add(hidden);
        }

        void butTrue_Click(object sender, ImageClickEventArgs e)
        {
            this.CurrentFilterFunction = GridKnownFunction.EqualTo;
            this.CurrentFilterValue = "true";
            Pair arg = new Pair(GridKnownFunction.EqualTo.ToString(), this.UniqueName);
            SetCurrentFilterValueToControl(((sender as Control).Parent as TableCell));

            ((sender as Control).NamingContainer as GridFilteringItem).FireCommandEvent(RadGrid.FilterCommandName, arg);
        }
        

        void butFalse_Click(object sender, ImageClickEventArgs e)
        {
            this.CurrentFilterFunction = GridKnownFunction.EqualTo;
            this.CurrentFilterValue = "false";
            Pair arg = new Pair(GridKnownFunction.EqualTo.ToString(), this.UniqueName);
            SetCurrentFilterValueToControl(((sender as Control).Parent as TableCell));

            ((sender as Control).NamingContainer as GridFilteringItem).FireCommandEvent(RadGrid.FilterCommandName, arg);
        }

        void butClear_Click(object sender, ImageClickEventArgs e)
        {
            this.CurrentFilterFunction = GridKnownFunction.NoFilter;
            this.CurrentFilterValue = String.Empty;
            Pair arg = new Pair(GridKnownFunction.NoFilter.ToString(), this.UniqueName);
            SetCurrentFilterValueToControl(((sender as Control).Parent as TableCell));

            ((sender as Control).NamingContainer as GridFilteringItem).FireCommandEvent(RadGrid.FilterCommandName, arg);
        }


    }
}
